package projectMonorail.Extras;

import java.awt.*;

public class DrawingNormalWheels implements IDrawingWheels {

    private WheelNumber wheelNumber;

    @Override
    public WheelNumber getWheelNumber() {
        return wheelNumber;
    }

    @Override
    public void setWheelNumber(int number) {
        switch (number) {
            case 2:
                wheelNumber = WheelNumber.Two;
                break;
            case 3:
                wheelNumber = WheelNumber.Three;
                break;
            case 4:
                wheelNumber = WheelNumber.Four;
                break;
            default:
                wheelNumber = WheelNumber.Two;
        }
    }

    @Override
    public void drawWheels(Graphics2D g2d, Color color, int startPosX, int startPosY) {
        switch (wheelNumber) {
            case Two:
                drawTwoWheels(g2d, color, startPosX, startPosY);
                break;
            case Three:
                drawThreeWheels(g2d, color, startPosX, startPosY);
                break;
            case Four:
                drawFourWheels(g2d, color, startPosX, startPosY);
                break;
        }
    }

    private void drawTwoWheels(Graphics2D g2d, Color color, int startPosX, int startPosY) {
        g2d.setColor(color);

        g2d.fillOval(startPosX + 25, startPosY + 47, 10, 9);
        g2d.fillOval(startPosX + 45, startPosY + 47, 10, 9);
        g2d.fillOval(startPosX + 75, startPosY + 47, 10, 9);
        g2d.fillOval(startPosX + 95, startPosY + 47, 10, 9);

        g2d.setColor(Color.BLACK);

        g2d.drawOval(startPosX + 25, startPosY + 47, 10, 9);
        g2d.drawOval(startPosX + 45, startPosY + 47, 10, 9);
        g2d.drawOval(startPosX + 75, startPosY + 47, 10, 9);
        g2d.drawOval(startPosX + 95, startPosY + 47, 10, 9);
    }

    private void drawThreeWheels(Graphics2D g2d, Color color, int startPosX, int startPosY) {
        g2d.setColor(color);

        g2d.fillOval(startPosX + 25, startPosY + 47, 8, 9);
        g2d.fillOval(startPosX + 36, startPosY + 47, 8, 9);
        g2d.fillOval(startPosX + 47, startPosY + 47, 8, 9);
        g2d.fillOval(startPosX + 76, startPosY + 47, 8, 9);
        g2d.fillOval(startPosX + 87, startPosY + 47, 8, 9);
        g2d.fillOval(startPosX + 98, startPosY + 47, 8, 9);

        g2d.setColor(Color.BLACK);

        g2d.drawOval(startPosX + 25, startPosY + 47, 8, 9);
        g2d.drawOval(startPosX + 36, startPosY + 47, 8, 9);
        g2d.drawOval(startPosX + 47, startPosY + 47, 8, 9);
        g2d.drawOval(startPosX + 76, startPosY + 47, 8, 9);
        g2d.drawOval(startPosX + 87, startPosY + 47, 8, 9);
        g2d.drawOval(startPosX + 98, startPosY + 47, 8, 9);
    }

    private void drawFourWheels(Graphics2D g2d, Color color, int startPosX, int startPosY) {
        g2d.setColor(color);

        g2d.fillOval(startPosX + 25, startPosY + 47, 6, 9);
        g2d.fillOval(startPosX + 33, startPosY + 47, 6, 9);
        g2d.fillOval(startPosX + 41, startPosY + 47, 6, 9);
        g2d.fillOval(startPosX + 49, startPosY + 47, 6, 9);
        g2d.fillOval(startPosX + 75, startPosY + 47, 6, 9);
        g2d.fillOval(startPosX + 83, startPosY + 47, 6, 9);
        g2d.fillOval(startPosX + 91, startPosY + 47, 6, 9);
        g2d.fillOval(startPosX + 99, startPosY + 47, 6, 9);

        g2d.setColor(Color.BLACK);

        g2d.drawOval(startPosX + 25, startPosY + 47, 6, 9);
        g2d.drawOval(startPosX + 33, startPosY + 47, 6, 9);
        g2d.drawOval(startPosX + 41, startPosY + 47, 6, 9);
        g2d.drawOval(startPosX + 49, startPosY + 47, 6, 9);
        g2d.drawOval(startPosX + 76, startPosY + 47, 6, 9);
        g2d.drawOval(startPosX + 84, startPosY + 47, 6, 9);
        g2d.drawOval(startPosX + 92, startPosY + 47, 6, 9);
        g2d.drawOval(startPosX + 100, startPosY + 47, 6, 9);
    }
}
