package projectMonorail.Extras;

import java.awt.*;

public class DrawingVintageWheels implements IDrawingWheels {

    private WheelNumber wheelNumber;

    @Override
    public WheelNumber getWheelNumber() {
        return wheelNumber;
    }

    @Override
    public void setWheelNumber(int number) {
        switch (number) {
            case 2:
                wheelNumber = WheelNumber.Two;
                break;
            case 3:
                wheelNumber = WheelNumber.Three;
                break;
            case 4:
                wheelNumber = WheelNumber.Four;
                break;
            default:
                wheelNumber = WheelNumber.Two;
        }
    }

    @Override
    public void drawWheels(Graphics2D g2d, Color color, int startPosX, int startPosY) {
        switch (wheelNumber) {
            case Two:
                drawTwoWheels(g2d, color, startPosX, startPosY);
                break;
            case Three:
                drawThreeWheels(g2d, color, startPosX, startPosY);
                break;
            case Four:
                drawFourWheels(g2d, color, startPosX, startPosY);
                break;
        }
    }

    private void drawTwoWheels(Graphics2D g2d, Color color, int startPosX, int startPosY) {
        g2d.setColor(color);

        g2d.fillOval(startPosX + 25, startPosY + 47, 10, 9);
        g2d.fillOval(startPosX + 45, startPosY + 47, 10, 9);
        g2d.fillOval(startPosX + 75, startPosY + 47, 10, 9);
        g2d.fillOval(startPosX + 95, startPosY + 47, 10, 9);

        g2d.setColor(Color.BLACK);

        drawWheel(g2d, startPosX, startPosY, 25, 47, 10, 9);
        drawWheel(g2d, startPosX, startPosY, 45, 47, 10, 9);
        drawWheel(g2d, startPosX, startPosY, 75, 47, 10, 9);
        drawWheel(g2d, startPosX, startPosY, 95, 47, 10, 9);
    }

    private void drawThreeWheels(Graphics2D g2d, Color color, int startPosX, int startPosY) {
        g2d.setColor(color);

        g2d.fillOval(startPosX + 25, startPosY + 47, 8, 9);
        g2d.fillOval(startPosX + 36, startPosY + 47, 8, 9);
        g2d.fillOval(startPosX + 47, startPosY + 47, 8, 9);
        g2d.fillOval(startPosX + 76, startPosY + 47, 8, 9);
        g2d.fillOval(startPosX + 87, startPosY + 47, 8, 9);
        g2d.fillOval(startPosX + 98, startPosY + 47, 8, 9);

        g2d.setColor(Color.BLACK);

        drawWheel(g2d, startPosX, startPosY, 25, 47, 8, 9);
        drawWheel(g2d, startPosX, startPosY, 36, 47, 8, 9);
        drawWheel(g2d, startPosX, startPosY, 47, 47, 8, 9);
        drawWheel(g2d, startPosX, startPosY, 76, 47, 8, 9);
        drawWheel(g2d, startPosX, startPosY, 87, 47, 8, 9);
        drawWheel(g2d, startPosX, startPosY, 98, 47, 8, 9);
    }

    private void drawFourWheels(Graphics2D g2d, Color color, int startPosX, int startPosY) {
        g2d.setColor(color);

        g2d.fillOval(startPosX + 25, startPosY + 47, 6, 9);
        g2d.fillOval(startPosX + 33, startPosY + 47, 6, 9);
        g2d.fillOval(startPosX + 41, startPosY + 47, 6, 9);
        g2d.fillOval(startPosX + 49, startPosY + 47, 6, 9);
        g2d.fillOval(startPosX + 75, startPosY + 47, 6, 9);
        g2d.fillOval(startPosX + 83, startPosY + 47, 6, 9);
        g2d.fillOval(startPosX + 91, startPosY + 47, 6, 9);
        g2d.fillOval(startPosX + 99, startPosY + 47, 6, 9);

        g2d.setColor(Color.BLACK);

        drawWheel(g2d, startPosX, startPosY, 25, 47, 6, 9);
        drawWheel(g2d, startPosX, startPosY, 33, 47, 6, 9);
        drawWheel(g2d, startPosX, startPosY, 41, 47, 6, 9);
        drawWheel(g2d, startPosX, startPosY, 49, 47, 6, 9);
        drawWheel(g2d, startPosX, startPosY, 75, 47, 6, 9);
        drawWheel(g2d, startPosX, startPosY, 83, 47, 6, 9);
        drawWheel(g2d, startPosX, startPosY, 91, 47, 6, 9);
        drawWheel(g2d, startPosX, startPosY, 99, 47, 6, 9);
    }

    private void drawWheel(Graphics2D g2d, int startPosX, int startPosY, int xChange, int yChange, int width, int height) {
        g2d.setStroke(new BasicStroke(1));
        g2d.drawOval(startPosX + xChange, startPosY + yChange, width, height);

        g2d.drawLine(startPosX + xChange + width/2, startPosY + yChange, startPosX + xChange + width/2, startPosY + yChange + height);
        g2d.drawLine(startPosX + xChange, startPosY + yChange + height/2, startPosX + xChange + width, startPosY + yChange + height/2);
        g2d.drawLine(startPosX + xChange + width/8, startPosY + yChange + height/8,
                startPosX + xChange + width * 7/8, startPosY + yChange + height * 7/8);
        g2d.drawLine(startPosX + xChange + width * 7/8, startPosY + yChange + height/8,
                startPosX + xChange + width/8, startPosY + yChange + height * 7/8);
    }
}
