package projectMonorail.Generics;

public class SetGeneric<T extends Object> {
    private final T[] places;

    public int count() {
        return places.length;
    }

    public SetGeneric(int count) {
        places = (T[])new Object[count];
    }

    public int insert(T locomotive) {
        return insert(locomotive, 0);
    }

    public int insert(T locomotive, int position) {
        int nullIndex = -1, i;

        if (position < 0 || position >= count())
            return -1;

        for (i = position; i < count(); i++) {
            if (places[i] == null) {
                nullIndex = i;
                break;
            }
        }
        if (nullIndex < 0)
            return -1;

        for (i = nullIndex; i > position; i--) {
            places[i] = places[i - 1];
        }

        places[position] = locomotive;
        return position;
    }

    public boolean remove(int position) {
        if (position < 0 || position >= count())
            return false;
        places[position] = null;
        return true;
    }

    public T get(int position) {
        if (position < 0 || position >= count())
            return null;
        return places[position];
    }
}
