package projectMonorail.MovementStrategy;


import projectMonorail.DirectionType;
import projectMonorail.DrawingObjects.DrawingLocomotive;

public class DrawingObjectLocomotive implements IMoveableObject {

    private DrawingLocomotive drawingLocomotive = null;

    public DrawingObjectLocomotive(DrawingLocomotive drawingLocomotive) {
        this.drawingLocomotive = drawingLocomotive;
    }

    @Override
    public ObjectParameters getObjectsPosition() {
        if (drawingLocomotive == null || drawingLocomotive.getEntityLocomotive() == null) {
            return null;
        }
        return new ObjectParameters(drawingLocomotive.getPosX(), drawingLocomotive.getPosY(),
                drawingLocomotive.getWidth(), drawingLocomotive.getHeight());
    }

    @Override
    public int getStep() {
        if (drawingLocomotive == null)
            return 0;
        return (int) ((drawingLocomotive.getEntityLocomotive() != null) ? drawingLocomotive.getEntityLocomotive().getStep() : 0);
    }

    @Override
    public boolean checkCanMove(DirectionType direction) {
        if (drawingLocomotive == null)
            return false;
        return drawingLocomotive.canMove(direction);
    }

    @Override
    public void moveObject(DirectionType direction) {
        if (drawingLocomotive != null)
            drawingLocomotive.moveTransport(direction);
    }
}
