package projectMonorail;

import projectMonorail.DrawingObjects.*;
import projectMonorail.Generics.*;
import projectMonorail.MovementStrategy.*;

import javax.swing.*;
import java.awt.*;

public class PictureBoxCollection extends JPanel {
    private final LocomotivesGenericCollection<DrawingLocomotive, DrawingObjectLocomotive> locomotives;

    public PictureBoxCollection(LocomotivesGenericCollection<DrawingLocomotive, DrawingObjectLocomotive> locomotives,
                                int width, int height) {
        this.locomotives = locomotives;
        setMaximumSize(new Dimension(width, height));
    }

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        Graphics2D g2d = (Graphics2D) g;
        locomotives.showLocomotives(g2d);
    }
}
