package projectMonorail;

import projectMonorail.DrawingObjects.*;
import projectMonorail.Entities.*;
import projectMonorail.Extras.*;

import javax.swing.*;
import java.awt.*;

public class PictureBoxRandomGeneration extends JPanel {
    private RandomGeneric<EntityLocomotive, IDrawingWheels> randomGeneric;

    private DrawingLocomotive drawingLocomotive;

    private JButton buttonRandomCreation;

    public PictureBoxRandomGeneration(int width, int height) {
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

        buttonRandomCreation = new JButton("Create monorail");
        buttonRandomCreation.setFocusable(false);
        buttonRandomCreation.setMaximumSize(new Dimension(155, 36));
        buttonRandomCreation.setBorder(BorderFactory.createLineBorder(Color.black, 2));
        buttonRandomCreation.setBackground(Color.WHITE);
        buttonRandomCreation.setHorizontalTextPosition(JButton.CENTER);
        buttonRandomCreation.setVerticalTextPosition(JButton.CENTER);
        buttonRandomCreation.setAlignmentX(Component.CENTER_ALIGNMENT);

        buttonRandomCreation.addActionListener(e -> {
            drawingLocomotive = randomGeneric.getDrawingLocomotive();
            repaint();
        });

        add(Box.createVerticalStrut(height - 80));
        add(buttonRandomCreation);
        setPreferredSize(new Dimension(width, height));

        randomGeneric = new RandomGeneric<>(7, 3, width, height);
        randomGeneric.addItem(new EntityLocomotive(200, 2000, Color.RED));
        randomGeneric.addItem(new EntityLocomotive(200, 2000, Color.GREEN));
        randomGeneric.addItem(new EntityLocomotive(200, 2000, Color.BLUE));
        randomGeneric.addItem(new EntityLocomotive(200, 2000, Color.PINK));
        randomGeneric.addItem(new EntityMonorail(200, 2000, Color.WHITE, Color.BLUE,true, false));
        randomGeneric.addItem(new EntityMonorail(200, 2000, Color.ORANGE, Color.LIGHT_GRAY,false, true));
        randomGeneric.addItem(new EntityMonorail(200, 2000, Color.CYAN, Color.MAGENTA,true, true));
        randomGeneric.addItem(new DrawingNormalWheels());
        randomGeneric.addItem(new DrawingVintageWheels());
        randomGeneric.addItem(new DrawingSquarePatternWheels());
    }

    @Override
    protected void paintComponent(Graphics g) {
        if (drawingLocomotive == null) {
            return;
        }

        super.paintComponent(g);
        Graphics2D g2d = (Graphics2D) g;
        drawingLocomotive.setPosition(getWidth() * 27 / 100, getHeight() * 3 / 10);
        drawingLocomotive.drawTransport(g2d);
    }
}
